      SUBROUTINE F(T,X,U,UX,UXX,FVAL,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE), UX(NPDE), UXX(NPDE), FVAL(NPDE)
        FVAL(1) = U(2)*U(2)*UXX(1) - U(1)*U(2) - U(1)**2 + 10.D+00
     X              + 2.D+00*U(2)*UX(2)*UX(1)
        FVAL(2) = U(1)*U(1)*UXX(2) + U(1)*U(2) - U(2)**2
     X          + UXX(1) + 2.D+00*U(1)*UX(1)*UX(2)
      RETURN
      END
      SUBROUTINE BNDRY(T,X,U,UX,DBDU,DBDUX,DZDT,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE), UX(NPDE), DZDT(NPDE)
      DIMENSION DBDU(NPDE,NPDE), DBDUX(NPDE,NPDE)
      COMMON /ENDPT/ XLEFT
      IF( X .NE. XLEFT ) GO TO 10
        DBDU(1,1) = 1.D+00
        DBDU(1,2) = 0.D+00
        DBDU(2,1) = 0.D+00
        DBDU(2,2) = 1.D+00
        DBDUX(1,1) = 0.D+00
        DBDUX(1,2) = 0.D+00
        DBDUX(2,1) = 0.D+00
        DBDUX(2,2) = 0.D+00
        DZDT(1) = 0.D+00
        DZDT(2) = 0.D+00
      RETURN
   10   DBDU(1,1) = U(2) * DCOS( U(1) * U(2) )
        DBDU(1,2) = U(1) * DCOS( U(1) * U(2) )
        DBDU(2,1) = U(2) * DSIN( U(1) * U(2) )
        DBDU(2,2) = U(1) * DSIN( U(1) * U(2) )
        DBDUX(1,1) = 1.D+00
        DBDUX(1,2) = 0.D+00
        DBDUX(2,1) = 0.D+00
        DBDUX(2,2) = 1.D+00
        DZDT(1) = 0.D+00
        DZDT(2) = 0.D+00
      RETURN
      END
      SUBROUTINE UINIT(X,U,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE)
C
C SET INITIAL CONDITIONS.  NOTE THAT  PI = 4.*ATAN(1.)
C
        U(1) = .5D+00 * ( X + 1.D+00 )
        U(2) = 4.D+00*DATAN(1.D+00)
      RETURN
      END
      SUBROUTINE DERIVF(T,X,U,UX,UXX,DFDU,DFDUX,DFDUXX,NPDE)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION U(NPDE), UX(NPDE), UXX(NPDE)
      DIMENSION DFDU(NPDE,NPDE), DFDUX(NPDE,NPDE), DFDUXX(NPDE,NPDE)
        DFDU(1,1) = -U(2) - 2.D+00*U(1)
        DFDU(1,2) = 2.D+00*U(2)*UXX(1) - U(1) + 2.D+00*UX(2)*UX(1)
        DFDU(2,1) = 2.D+00*U(1)*UXX(2) + U(2) + 2.D+00*UX(1)*UX(2)
        DFDU(2,2) = U(1) - 2.D+00*U(2)
C
        DFDUX(1,1) = 2.D+00*U(2)*UX(2)
        DFDUX(1,2) = 2.D+00*U(2)*UX(1)
        DFDUX(2,1) = 2.D+00*U(1)*UX(2)
        DFDUX(2,2) = 2.D+00*U(1)*UX(1)
C
        DFDUXX(1,1) = U(2)*U(2)
        DFDUXX(1,2) = 0.D+00
        DFDUXX(2,1) = 1.D+00
        DFDUXX(2,2) = U(1)*U(1)
      RETURN
      END
